package com.gic.auth.service;


import com.gic.auth.dto.MenuDTO;
import com.gic.auth.entity.TabSysMenu;
import com.gic.auth.qo.MenuListQO;

import java.util.List;

public interface MenuService {
    List<TabSysMenu> listMenu(MenuListQO params);

    TabSysMenu getMenuById(Integer menuId);

    /**
     * 新增页面
     * @Title: savePage 
     * @Description:
      * @author guojuxing
     * @param menuDTO 
     * @return  void 
      */
    void savePage(MenuDTO menuDTO);

    /**
     * 获取当前最大排序值
     * @Title: getMaxSortByParentIdAndLevel 
     * @Description:
      * @author guojuxing
     * @param parentId 父级ID
     * @param project
     * @return  int 
      */
    int getMaxSortByParentId(Integer parentId, String project);

    /**
     * @Title: updatePage 
     * @Description: 
      * @author guojuxing 
 * @param menuDTO 
     * @return  void 
      */
    void updatePage(MenuDTO menuDTO);

    /**
     * 查询页面下面的权限项列表数据
     * @Title: listMenuRoleByParentId 
     * @Description:
      * @author guojuxing
     * @param parentId 
     * @return  java.util.List<com.gic.auth.entity.TabSysMenu> 
      */
    List<TabSysMenu> listMenuRoleByParentId(Integer parentId);
}
