package com.gic.auth.service.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.auth.dao.mapper.TabSysMenuMapper;
import com.gic.auth.dto.MenuDTO;
import com.gic.auth.entity.TabSysMenu;
import com.gic.auth.qo.MenuListQO;
import com.gic.auth.service.MenuService;
import com.gic.commons.util.EntityUtil;
@Service("menuService")
public class MenuServiceImpl implements MenuService {
    @Autowired
    private TabSysMenuMapper tabSysMenuMapper;
    @Override
    public List<TabSysMenu> listMenu(MenuListQO params) {
        return this.tabSysMenuMapper.listMenu(params);
    }

    @Override
    public TabSysMenu getMenuById(Integer menuId) {
        return this.tabSysMenuMapper.selectByPrimaryKey(menuId);
    }

    @Override
    public void savePage(MenuDTO menuDTO) {
        TabSysMenu record = EntityUtil.changeEntityNew(TabSysMenu.class, menuDTO);
        record.setCreateTime(new Date());
        record.setUpdateTime(new Date());
        record.setStatus(1);
        tabSysMenuMapper.insertSelective(record);
    }

    @Override
    public int getMaxSortByParentId(Integer parentId,  String project) {
        return tabSysMenuMapper.getMaxSortByParentId(parentId, project);
    }

    @Override
    public void updatePage(MenuDTO menuDTO) {
        TabSysMenu record = EntityUtil.changeEntityNew(TabSysMenu.class, menuDTO);
        record.setUpdateTime(new Date());
        tabSysMenuMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public List<TabSysMenu> listMenuRoleByParentId(Integer parentId) {
        List<TabSysMenu> list = tabSysMenuMapper.listMenuRoleByParentId(parentId);
        if (CollectionUtils.isNotEmpty(list)) {
            return list;
        }
        return new ArrayList<>();
    }
}
